package SoE is

   --  any range limit you like
   Limit : constant Positive := 10;

   type Container_T is array (1 .. Limit) of Integer;

   --+------------------------------
   --  a protected resource type
   --+ that will hold the integer
   --+ values exchanged by the Sieve
   --+ process instances
   --+------------------------------
   protected type Buffer_T is
      entry Put (Item :        Integer);
      entry Get (Item :    out Integer);
   private
      A_Container : Container_T;
      Insert,
      Extract     : Positive := 1;
      Contents    : Natural  := 0;
   end Buffer_T;
   --+------------------------------

   --  the process that will pass all
   --+ odd numbers in the given interval
   --+ on to the chain of Sieve processes
   --+ for analysis
   --+--------------------------------
   task Odd;
   --+--------------------------------

   --  the type of the Sieve processes
   --+--------------------------------
   task type Sieve_T (B  : access Buffer_T;
                      Id : Positive);
   type Sieve_Ref is access Sieve_T;
   --+--------------------------------

   --  a function that dynamically create
   --+ an process instance of type Sieve_T
   function New_Sieve (B : access Buffer_T) return Sieve_Ref;
   --+---------------------------------

end SoE;
